#include <sys/midi.h>
#include <sys/stropts.h>
#include <sys/fcntl.h>
#include <stdio.h>
#include <poll.h>

main()
{
	int n, f, r, i;
	char buff[12];
	long tm;
	struct strioctl opts_strioctl;
	struct pollfd pollfds[32];
	extern int errno;

	/* n = open("/dev/midi",O_RDWR); */
	n = open("/dev/midi",2);
	if ( n < 0 ) {
		fprintf(stderr,"n=%d  errno=%d\n",n,errno);
		exit(1);
	}
	fprintf(stderr,"n=%d\n",n);

#define TRYPOLL
#ifdef TRYPOLL
pollfds[0].fd = n;
pollfds[0].events = POLLIN;
errno = 0;
r = poll(pollfds,1,10000);
fprintf(stderr,"poll r=%d  errno=%d\n",r,errno);
r = poll(pollfds,1,10000);
fprintf(stderr,"poll2 r=%d  errno=%d\n",r,errno);
fprintf(stderr,"before read\n");
	buff[0] = buff[1] = buff[2] = 0;
	r = read(n,buff,3);
fprintf(stderr,"after read, r=%d  buff=0x%x,0x%x,0x%x\n",r,buff[0],buff[1],buff[2]);
#endif

	opts_strioctl.ic_cmd = MIDIACTIVE;
	opts_strioctl.ic_timout = 0;
	opts_strioctl.ic_len = 0;
	opts_strioctl.ic_dp = (char*)(&tm);

#ifdef TRYACTIVE
	r = ioctl(n,MIDIACTIVE, 0 /* &opts_strioctl */ );
fprintf(stderr,"MIDIACTIVE r=%d  errno=%d\n",r,errno);

	r = ioctl(n,I_STR,&opts_strioctl);
fprintf(stderr,"I_STR r=%d  errno=%d\n",r,errno);
#endif

#ifdef TRYTIME
	tm = 0;
	for ( i=0; i<10; i++ ) {
		r = ioctl(n,MIDISTAT, &tm );
fprintf(stderr,"MIDISTAT r=%d  errno=%d  tm=%ld\n",r,errno,tm);
		sleep(2);
	}
#endif

	/* buff[0] = 0x90;
	buff[1] =  64;
	buff[2] = 0x40;
	write(n,buff,3);
        sleep(2);
	buff[0] = 0x90;
	buff[1] =  64;
	buff[2] = 0;
	write(n,buff,3); */

	close(n);
}
